from _typeshed import Incomplete
from numpy import ma as ma
from numpy.lib import add_newdoc_ufunc as add_newdoc_ufunc, angle as angle, average as average, bartlett as bartlett, blackman as blackman, corrcoef as corrcoef, cov as cov, delete as delete, diff as diff, digitize as digitize, extract as extract, flipud as flipud, gradient as gradient, hamming as hamming, hanning as hanning, i0 as i0, insert as insert, interp as interp, kaiser as kaiser, meshgrid as meshgrid, msort as msort, piecewise as piecewise, place as place, rot90 as rot90, select as select, setxor1d as setxor1d, sinc as sinc, trapz as trapz, trim_zeros as trim_zeros, unique as unique, unwrap as unwrap, vectorize as vectorize
from numpy.random import rand as rand
from numpy.testing import HAS_REFCOUNT as HAS_REFCOUNT, IS_PYPY as IS_PYPY, assert_ as assert_, assert_allclose as assert_allclose, assert_almost_equal as assert_almost_equal, assert_array_almost_equal as assert_array_almost_equal, assert_array_equal as assert_array_equal, assert_equal as assert_equal, assert_raises as assert_raises, assert_raises_regex as assert_raises_regex, assert_warns as assert_warns, suppress_warnings as suppress_warnings

def get_mat(n): ...

class TestRot90:
    def test_basic(self) -> None: ...
    def test_axes(self) -> None: ...
    def test_rotation_axes(self) -> None: ...

class TestFlip:
    def test_axes(self) -> None: ...
    def test_basic_lr(self) -> None: ...
    def test_basic_ud(self) -> None: ...
    def test_3d_swap_axis0(self) -> None: ...
    def test_3d_swap_axis1(self) -> None: ...
    def test_3d_swap_axis2(self) -> None: ...
    def test_4d(self) -> None: ...
    def test_default_axis(self) -> None: ...
    def test_multiple_axes(self) -> None: ...

class TestAny:
    def test_basic(self) -> None: ...
    def test_nd(self) -> None: ...

class TestAll:
    def test_basic(self) -> None: ...
    def test_nd(self) -> None: ...

class TestCopy:
    def test_basic(self) -> None: ...
    def test_order(self) -> None: ...
    def test_subok(self) -> None: ...

class TestAverage:
    def test_basic(self) -> None: ...
    def test_basic_keepdims(self, x, axis, expected_avg, weights, expected_wavg, expected_wsum) -> None: ...
    def test_weights(self) -> None: ...
    def test_returned(self) -> None: ...
    def test_subclasses(self) -> None: ...
    def test_upcasting(self) -> None: ...
    def test_object_dtype(self) -> None: ...

class TestSelect:
    choices: Incomplete
    conditions: Incomplete
    def test_basic(self) -> None: ...
    def test_broadcasting(self) -> None: ...
    def test_return_dtype(self) -> None: ...
    def test_deprecated_empty(self) -> None: ...
    def test_non_bool_deprecation(self) -> None: ...
    def test_many_arguments(self) -> None: ...

class TestInsert:
    def test_basic(self) -> None: ...
    def test_multidim(self) -> None: ...
    def test_0d(self) -> None: ...
    def test_subclass(self) -> None: ...
    def test_index_array_copied(self) -> None: ...
    def test_structured_array(self) -> None: ...
    def test_index_floats(self) -> None: ...
    def test_index_out_of_bounds(self, idx) -> None: ...

class TestAmax:
    def test_basic(self) -> None: ...

class TestAmin:
    def test_basic(self) -> None: ...

class TestPtp:
    def test_basic(self) -> None: ...

class TestCumsum:
    def test_basic(self) -> None: ...

class TestProd:
    def test_basic(self) -> None: ...

class TestCumprod:
    def test_basic(self) -> None: ...

class TestDiff:
    def test_basic(self) -> None: ...
    def test_axis(self) -> None: ...
    def test_nd(self) -> None: ...
    def test_n(self) -> None: ...
    def test_times(self) -> None: ...
    def test_subclass(self) -> None: ...
    def test_prepend(self) -> None: ...
    def test_append(self) -> None: ...

class TestDelete:
    a: Incomplete
    nd_a: Incomplete
    def setup_method(self) -> None: ...
    def test_slices(self) -> None: ...
    def test_fancy(self) -> None: ...
    def test_single(self) -> None: ...
    def test_0d(self) -> None: ...
    def test_subclass(self) -> None: ...
    def test_array_order_preserve(self) -> None: ...
    def test_index_floats(self) -> None: ...
    def test_single_item_array(self, indexer) -> None: ...
    def test_single_item_array_non_int(self) -> None: ...

class TestGradient:
    def test_basic(self) -> None: ...
    def test_args(self) -> None: ...
    def test_badargs(self) -> None: ...
    def test_datetime64(self) -> None: ...
    def test_masked(self) -> None: ...
    def test_second_order_accurate(self) -> None: ...
    def test_spacing(self) -> None: ...
    def test_specific_axes(self) -> None: ...
    def test_timedelta64(self) -> None: ...
    def test_inexact_dtypes(self) -> None: ...
    def test_values(self) -> None: ...
    def test_f_decreasing_unsigned_int(self, f_dtype) -> None: ...
    def test_f_signed_int_big_jump(self, f_dtype) -> None: ...
    def test_x_decreasing_unsigned(self, x_dtype) -> None: ...
    def test_x_signed_int_big_jump(self, x_dtype) -> None: ...

class TestAngle:
    def test_basic(self) -> None: ...
    def test_subclass(self) -> None: ...

class TestTrimZeros:
    a: Incomplete
    b: Incomplete
    c: Incomplete
    d: Incomplete
    def values(self): ...
    def test_basic(self) -> None: ...
    def test_leading_skip(self) -> None: ...
    def test_trailing_skip(self) -> None: ...
    def test_all_zero(self) -> None: ...
    def test_size_zero(self) -> None: ...
    def test_overflow(self, arr) -> None: ...
    def test_no_trim(self) -> None: ...
    def test_list_to_list(self) -> None: ...

class TestExtins:
    def test_basic(self) -> None: ...
    def test_place(self): ...
    def test_both(self) -> None: ...

class TestVectorize:
    def test_simple(self): ...
    def test_scalar(self): ...
    def test_large(self): ...
    def test_ufunc(self) -> None: ...
    def test_keywords(self): ...
    def test_keywords_with_otypes_order1(self) -> None: ...
    def test_keywords_with_otypes_order2(self) -> None: ...
    def test_keywords_with_otypes_order3(self) -> None: ...
    def test_keywords_with_otypes_several_kwd_args1(self) -> None: ...
    def test_keywords_with_otypes_several_kwd_args2(self) -> None: ...
    def test_keywords_no_func_code(self) -> None: ...
    def test_keywords2_ticket_2100(self): ...
    def test_keywords3_ticket_2100(self): ...
    def test_keywords4_ticket_2100(self): ...
    def test_keywords5_ticket_2100(self): ...
    def test_coverage1_ticket_2100(self): ...
    def test_assigning_docstring(self): ...
    def test_UnboundMethod_ticket_1156(self): ...
    def test_execution_order_ticket_1487(self): ...
    def test_string_ticket_1892(self): ...
    def test_cache(self): ...
    def test_otypes(self): ...
    def test_parse_gufunc_signature(self) -> None: ...
    def test_signature_simple(self): ...
    def test_signature_mean_last(self): ...
    def test_signature_center(self): ...
    def test_signature_two_outputs(self): ...
    def test_signature_outer(self) -> None: ...
    def test_signature_computed_size(self): ...
    def test_signature_excluded(self): ...
    def test_signature_otypes(self): ...
    def test_signature_invalid_inputs(self) -> None: ...
    def test_signature_invalid_outputs(self): ...
    def test_size_zero_output(self): ...
    def test_subclasses(self): ...

class TestLeaks:
    class A:
        iters: int
        def bound(self, *args): ...
        @staticmethod
        def unbound(*args): ...
    def test_frompyfunc_leaks(self, name, incr) -> None: ...

class TestDigitize:
    def test_forward(self) -> None: ...
    def test_reverse(self) -> None: ...
    def test_random(self) -> None: ...
    def test_right_basic(self) -> None: ...
    def test_right_open(self) -> None: ...
    def test_right_open_reverse(self) -> None: ...
    def test_right_open_random(self) -> None: ...
    def test_monotonic(self) -> None: ...
    def test_casting_error(self) -> None: ...
    def test_return_type(self) -> None: ...
    def test_large_integers_increasing(self) -> None: ...
    def test_large_integers_decreasing(self) -> None: ...

class TestUnwrap:
    def test_simple(self) -> None: ...
    def test_period(self) -> None: ...

class TestFilterwindows:
    def test_hanning(self, dtype: str, M: int) -> None: ...
    def test_hamming(self, dtype: str, M: int) -> None: ...
    def test_bartlett(self, dtype: str, M: int) -> None: ...
    def test_blackman(self, dtype: str, M: int) -> None: ...
    def test_kaiser(self, dtype: str, M: int) -> None: ...

class TestTrapz:
    def test_simple(self) -> None: ...
    def test_ndim(self) -> None: ...
    def test_masked(self) -> None: ...

class TestSinc:
    def test_simple(self) -> None: ...
    def test_array_like(self) -> None: ...

class TestUnique:
    def test_simple(self) -> None: ...

class TestCheckFinite:
    def test_simple(self) -> None: ...
    def test_dtype_order(self) -> None: ...

class TestCorrCoef:
    A: Incomplete
    B: Incomplete
    res1: Incomplete
    res2: Incomplete
    def test_non_array(self) -> None: ...
    def test_simple(self) -> None: ...
    def test_ddof(self) -> None: ...
    def test_bias(self) -> None: ...
    def test_complex(self) -> None: ...
    def test_xy(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_extreme(self) -> None: ...
    def test_corrcoef_dtype(self, test_type) -> None: ...

class TestCov:
    x1: Incomplete
    res1: Incomplete
    x2: Incomplete
    frequencies: Incomplete
    x2_repeats: Incomplete
    res2: Incomplete
    unit_frequencies: Incomplete
    weights: Incomplete
    res3: Incomplete
    unit_weights: Incomplete
    x3: Incomplete
    def test_basic(self) -> None: ...
    def test_complex(self) -> None: ...
    def test_xy(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_wrong_ddof(self) -> None: ...
    def test_1D_rowvar(self) -> None: ...
    def test_1D_variance(self) -> None: ...
    def test_fweights(self) -> None: ...
    def test_aweights(self) -> None: ...
    def test_unit_fweights_and_aweights(self) -> None: ...
    def test_cov_dtype(self, test_type) -> None: ...

class Test_I0:
    def test_simple(self) -> None: ...
    def test_non_array(self): ...
    def test_complex(self) -> None: ...

class TestKaiser:
    def test_simple(self) -> None: ...
    def test_int_beta(self) -> None: ...

class TestMsort:
    def test_simple(self) -> None: ...

class TestMeshgrid:
    def test_simple(self) -> None: ...
    def test_single_input(self) -> None: ...
    def test_no_input(self) -> None: ...
    def test_indexing(self) -> None: ...
    def test_sparse(self) -> None: ...
    def test_invalid_arguments(self) -> None: ...
    def test_return_type(self) -> None: ...
    def test_writeback(self) -> None: ...
    def test_nd_shape(self) -> None: ...
    def test_nd_values(self) -> None: ...
    def test_nd_indexing(self) -> None: ...

class TestPiecewise:
    def test_simple(self): ...
    def test_two_conditions(self) -> None: ...
    def test_scalar_domains_three_conditions(self) -> None: ...
    def test_default(self) -> None: ...
    def test_0d(self) -> None: ...
    def test_0d_comparison(self) -> None: ...
    def test_0d_0d_condition(self) -> None: ...
    def test_multidimensional_extrafunc(self) -> None: ...
    def test_subclasses(self) -> None: ...

class TestBincount:
    def test_simple(self) -> None: ...
    def test_simple2(self) -> None: ...
    def test_simple_weight(self) -> None: ...
    def test_simple_weight2(self) -> None: ...
    def test_with_minlength(self) -> None: ...
    def test_with_minlength_smaller_than_maxvalue(self) -> None: ...
    def test_with_minlength_and_weights(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_empty_with_minlength(self) -> None: ...
    def test_with_incorrect_minlength(self): ...
    def test_dtype_reference_leaks(self) -> None: ...
    def test_error_not_1d(self, vals) -> None: ...

class TestInterp:
    def test_exceptions(self) -> None: ...
    def test_basic(self) -> None: ...
    def test_right_left_behavior(self) -> None: ...
    def test_scalar_interpolation_point(self) -> None: ...
    def test_non_finite_behavior_exact_x(self) -> None: ...
    def sc(self, request): ...
    def test_non_finite_any_nan(self, sc) -> None: ...
    def test_non_finite_inf(self, sc) -> None: ...
    def test_non_finite_half_inf_xf(self, sc) -> None: ...
    def test_non_finite_half_inf_x(self, sc) -> None: ...
    def test_non_finite_half_inf_f(self, sc) -> None: ...
    def test_complex_interp(self) -> None: ...
    def test_zero_dimensional_interpolation_point(self) -> None: ...
    def test_if_len_x_is_small(self) -> None: ...
    def test_period(self) -> None: ...

class TestPercentile:
    def test_basic(self) -> None: ...
    def test_fraction(self) -> None: ...
    def test_api(self) -> None: ...
    def test_2D(self) -> None: ...
    def test_linear_nan_1D(self, dtype) -> None: ...
    H_F_TYPE_CODES: Incomplete
    def test_linear_interpolation(self, method, expected, input_dtype, expected_dtype) -> None: ...
    TYPE_CODES: Incomplete
    def test_lower_higher(self, dtype) -> None: ...
    def test_midpoint(self, dtype) -> None: ...
    def test_nearest(self, dtype) -> None: ...
    def test_linear_interpolation_extrapolation(self) -> None: ...
    def test_sequence(self) -> None: ...
    def test_axis(self) -> None: ...
    def test_scalar_q(self) -> None: ...
    def test_exception(self) -> None: ...
    def test_percentile_list(self) -> None: ...
    def test_percentile_out(self) -> None: ...
    def test_percentile_empty_dim(self) -> None: ...
    def test_percentile_no_overwrite(self) -> None: ...
    def test_no_p_overwrite(self) -> None: ...
    def test_percentile_overwrite(self) -> None: ...
    def test_extended_axis(self) -> None: ...
    def test_extended_axis_invalid(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_out(self) -> None: ...
    def test_out_nan(self) -> None: ...
    def test_nan_behavior(self) -> None: ...
    def test_nan_q(self) -> None: ...

class TestQuantile:
    def test_max_ulp(self) -> None: ...
    def test_basic(self) -> None: ...
    def test_correct_quantile_value(self) -> None: ...
    def test_fraction(self) -> None: ...
    def test_no_p_overwrite(self) -> None: ...
    def test_quantile_preserve_int_type(self, dtype) -> None: ...
    def test_quantile_monotonic(self, method) -> None: ...
    def test_quantile_monotonic_hypo(self, arr) -> None: ...
    def test_quantile_scalar_nan(self) -> None: ...

class TestLerp:
    def test_linear_interpolation_formula_monotonic(self, t0, t1, a, b) -> None: ...
    def test_linear_interpolation_formula_bounded(self, t, a, b) -> None: ...
    def test_linear_interpolation_formula_symmetric(self, t, a, b) -> None: ...
    def test_linear_interpolation_formula_0d_inputs(self) -> None: ...

class TestMedian:
    def test_basic(self) -> None: ...
    def test_axis_keyword(self) -> None: ...
    def test_overwrite_keyword(self) -> None: ...
    def test_array_like(self) -> None: ...
    def test_subclass(self): ...
    def test_subclass2(self, arr) -> None: ...
    def test_out(self) -> None: ...
    def test_out_nan(self) -> None: ...
    def test_nan_behavior(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_object(self) -> None: ...
    def test_extended_axis(self) -> None: ...
    def test_extended_axis_invalid(self) -> None: ...
    def test_keepdims(self) -> None: ...

class TestAdd_newdoc_ufunc:
    def test_ufunc_arg(self) -> None: ...
    def test_string_arg(self) -> None: ...

class TestAdd_newdoc:
    def test_add_doc(self) -> None: ...
    def test_errors_are_ignored(self) -> None: ...

class TestAddDocstring:
    def test_add_same_docstring(self) -> None: ...
    def test_different_docstring_fails(self) -> None: ...

class TestSortComplex:
    def test_sort_real(self, type_in, type_out) -> None: ...
    def test_sort_complex(self) -> None: ...
