from numpy.lib.histograms import histogram as histogram, histogram_bin_edges as histogram_bin_edges, histogramdd as histogramdd
from numpy.testing import assert_ as assert_, assert_allclose as assert_allclose, assert_almost_equal as assert_almost_equal, assert_array_almost_equal as assert_array_almost_equal, assert_array_equal as assert_array_equal, assert_array_max_ulp as assert_array_max_ulp, assert_equal as assert_equal, assert_raises as assert_raises, assert_raises_regex as assert_raises_regex, suppress_warnings as suppress_warnings
from numpy.testing._private.utils import requires_memory as requires_memory

class TestHistogram:
    def setup_method(self) -> None: ...
    def teardown_method(self) -> None: ...
    def test_simple(self) -> None: ...
    def test_one_bin(self) -> None: ...
    def test_normed(self) -> None: ...
    def test_density(self) -> None: ...
    def test_outliers(self) -> None: ...
    def test_arr_weights_mismatch(self) -> None: ...
    def test_type(self) -> None: ...
    def test_f32_rounding(self) -> None: ...
    def test_bool_conversion(self) -> None: ...
    def test_weights(self) -> None: ...
    def test_exotic_weights(self) -> None: ...
    def test_no_side_effects(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_error_binnum_type(self) -> None: ...
    def test_finite_range(self) -> None: ...
    def test_invalid_range(self) -> None: ...
    def test_bin_edge_cases(self) -> None: ...
    def test_last_bin_inclusive_range(self) -> None: ...
    def test_bin_array_dims(self) -> None: ...
    def test_unsigned_monotonicity_check(self) -> None: ...
    def test_object_array_of_0d(self) -> None: ...
    def test_some_nan_values(self) -> None: ...
    def test_datetime(self) -> None: ...
    def do_signed_overflow_bounds(self, dtype) -> None: ...
    def test_signed_overflow_bounds(self) -> None: ...
    def do_precision_lower_bound(self, float_small, float_large) -> None: ...
    def do_precision_upper_bound(self, float_small, float_large) -> None: ...
    def do_precision(self, float_small, float_large) -> None: ...
    def test_precision(self) -> None: ...
    def test_histogram_bin_edges(self) -> None: ...
    def test_big_arrays(self) -> None: ...

class TestHistogramOptimBinNums:
    def test_empty(self) -> None: ...
    def test_simple(self) -> None: ...
    def test_small(self) -> None: ...
    def test_incorrect_methods(self) -> None: ...
    def test_novariance(self) -> None: ...
    def test_limited_variance(self) -> None: ...
    def test_outlier(self) -> None: ...
    def test_scott_vs_stone(self): ...
    def test_simple_range(self) -> None: ...
    def test_signed_integer_data(self, bins) -> None: ...
    def test_simple_weighted(self) -> None: ...

class TestHistogramdd:
    def test_simple(self) -> None: ...
    def test_shape_3d(self) -> None: ...
    def test_shape_4d(self) -> None: ...
    def test_weights(self) -> None: ...
    def test_identical_samples(self) -> None: ...
    def test_empty(self) -> None: ...
    def test_bins_errors(self) -> None: ...
    def test_inf_edges(self) -> None: ...
    def test_rightmost_binedge(self) -> None: ...
    def test_finite_range(self) -> None: ...
    def test_equal_edges(self) -> None: ...
    def test_edge_dtype(self) -> None: ...
    def test_large_integers(self) -> None: ...
    def test_density_non_uniform_2d(self) -> None: ...
    def test_density_non_uniform_1d(self) -> None: ...
    def test_density_via_normed(self) -> None: ...
    def test_density_normed_redundancy(self) -> None: ...
