from _typeshed import Incomplete
from io import BytesIO
from numpy.compat import asbytes as asbytes
from numpy.lib._iotools import ConversionWarning as ConversionWarning, ConverterError as ConverterError
from numpy.ma.testutils import assert_equal as assert_equal
from numpy.testing import HAS_REFCOUNT as HAS_REFCOUNT, IS_PYPY as IS_PYPY, assert_ as assert_, assert_allclose as assert_allclose, assert_array_equal as assert_array_equal, assert_no_gc_cycles as assert_no_gc_cycles, assert_no_warnings as assert_no_warnings, assert_raises as assert_raises, assert_raises_regex as assert_raises_regex, assert_warns as assert_warns, break_cycles as break_cycles, suppress_warnings as suppress_warnings, tempdir as tempdir, temppath as temppath
from numpy.testing._private.utils import requires_memory as requires_memory

class TextIO(BytesIO):
    def __init__(self, s: str = '') -> None: ...
    def write(self, s) -> None: ...
    def writelines(self, lines) -> None: ...

IS_64BIT: Incomplete
HAS_BZ2: bool
HAS_LZMA: bool

def strptime(s, fmt: Incomplete | None = None): ...

class RoundtripTest:
    arr: Incomplete
    arr_reloaded: Incomplete
    def roundtrip(self, save_func, *args, **kwargs) -> None: ...
    def check_roundtrips(self, a) -> None: ...
    def test_array(self) -> None: ...
    def test_array_object(self) -> None: ...
    def test_1D(self) -> None: ...
    def test_mmap(self) -> None: ...
    def test_record(self) -> None: ...
    def test_format_2_0(self) -> None: ...

class TestSaveLoad(RoundtripTest):
    def roundtrip(self, *args, **kwargs) -> None: ...

class TestSavezLoad(RoundtripTest):
    def roundtrip(self, *args, **kwargs) -> None: ...
    def test_big_arrays(self) -> None: ...
    def test_multiple_arrays(self) -> None: ...
    def test_named_arrays(self) -> None: ...
    def test_BagObj(self) -> None: ...
    def test_savez_filename_clashes(self) -> None: ...
    def test_not_closing_opened_fid(self) -> None: ...
    def test_closing_fid(self) -> None: ...
    def test_closing_zipfile_after_load(self) -> None: ...

class TestSaveTxt:
    def test_array(self) -> None: ...
    def test_1D(self) -> None: ...
    def test_0D_3D(self) -> None: ...
    def test_structured(self) -> None: ...
    def test_structured_padded(self) -> None: ...
    def test_multifield_view(self) -> None: ...
    def test_delimiter(self) -> None: ...
    def test_format(self) -> None: ...
    def test_header_footer(self) -> None: ...
    def test_file_roundtrip(self) -> None: ...
    def test_complex_arrays(self) -> None: ...
    def test_complex_negative_exponent(self) -> None: ...
    def test_custom_writer(self) -> None: ...
    def test_unicode(self) -> None: ...
    def test_unicode_roundtrip(self) -> None: ...
    def test_unicode_bytestream(self) -> None: ...
    def test_unicode_stringstream(self) -> None: ...
    def test_unicode_and_bytes_fmt(self, fmt, iotype) -> None: ...
    def test_large_zip(self) -> None: ...

class LoadTxtBase:
    def check_compressed(self, fopen, suffixes) -> None: ...
    def test_compressed_gzip(self) -> None: ...
    def test_compressed_bz2(self) -> None: ...
    def test_compressed_lzma(self) -> None: ...
    def test_encoding(self) -> None: ...
    def test_stringload(self) -> None: ...
    def test_binary_decode(self) -> None: ...
    def test_converters_decode(self): ...
    def test_converters_nodecode(self): ...

class TestLoadTxt(LoadTxtBase):
    loadfunc: Incomplete
    orig_chunk: Incomplete
    def setup_method(self) -> None: ...
    def teardown_method(self) -> None: ...
    def test_record(self) -> None: ...
    def test_array(self) -> None: ...
    def test_1D(self) -> None: ...
    def test_missing(self): ...
    def test_converters_with_usecols(self): ...
    def test_comments_unicode(self) -> None: ...
    def test_comments_byte(self) -> None: ...
    def test_comments_multiple(self) -> None: ...
    def test_comments_multi_chars(self) -> None: ...
    def test_skiprows(self) -> None: ...
    def test_usecols(self): ...
    def test_bad_usecols(self) -> None: ...
    def test_fancy_dtype(self) -> None: ...
    def test_shaped_dtype(self) -> None: ...
    def test_3d_shaped_dtype(self) -> None: ...
    def test_str_dtype(self) -> None: ...
    def test_empty_file(self) -> None: ...
    def test_unused_converter(self): ...
    def test_dtype_with_object(self): ...
    def test_uint64_type(self) -> None: ...
    def test_int64_type(self) -> None: ...
    def test_from_float_hex(self) -> None: ...
    def test_default_float_converter_no_default_hex_conversion(self) -> None: ...
    def test_default_float_converter_exception(self) -> None: ...
    def test_from_complex(self) -> None: ...
    def test_complex_misformatted(self) -> None: ...
    def test_universal_newline(self) -> None: ...
    def test_empty_field_after_tab(self) -> None: ...
    def test_unpack_structured(self) -> None: ...
    def test_ndmin_keyword(self) -> None: ...
    def test_generator_source(self) -> None: ...
    def test_bad_line(self) -> None: ...
    def test_none_as_string(self) -> None: ...
    def test_binary_load(self) -> None: ...
    def test_max_rows(self) -> None: ...
    def test_max_rows_with_skiprows(self) -> None: ...
    def test_max_rows_with_read_continuation(self) -> None: ...
    def test_max_rows_larger(self) -> None: ...
    def test_max_rows_empty_lines(self, skip, data) -> None: ...

class Testfromregex:
    def test_record(self) -> None: ...
    def test_record_2(self) -> None: ...
    def test_record_3(self) -> None: ...
    def test_record_unicode(self, path_type) -> None: ...
    def test_compiled_bytes(self) -> None: ...
    def test_bad_dtype_not_structured(self) -> None: ...

class TestFromTxt(LoadTxtBase):
    loadfunc: Incomplete
    def test_record(self) -> None: ...
    def test_array(self) -> None: ...
    def test_1D(self) -> None: ...
    def test_comments(self) -> None: ...
    def test_skiprows(self) -> None: ...
    def test_skip_footer(self) -> None: ...
    def test_skip_footer_with_invalid(self) -> None: ...
    def test_header(self) -> None: ...
    def test_auto_dtype(self) -> None: ...
    def test_auto_dtype_uniform(self) -> None: ...
    def test_fancy_dtype(self) -> None: ...
    def test_names_overwrite(self) -> None: ...
    def test_bad_fname(self) -> None: ...
    def test_commented_header(self) -> None: ...
    def test_names_and_comments_none(self) -> None: ...
    def test_file_is_closed_on_error(self) -> None: ...
    def test_autonames_and_usecols(self) -> None: ...
    def test_converters_with_usecols(self): ...
    def test_converters_with_usecols_and_names(self): ...
    def test_converters_cornercases(self): ...
    def test_converters_cornercases2(self): ...
    def test_unused_converter(self): ...
    def test_invalid_converter(self): ...
    def test_tricky_converter_bug1666(self): ...
    def test_dtype_with_converters(self) -> None: ...
    def test_dtype_with_converters_and_usecols(self): ...
    def test_dtype_with_object(self): ...
    def test_dtype_with_object_no_converter(self) -> None: ...
    def test_userconverters_with_explicit_dtype(self) -> None: ...
    def test_utf8_userconverters_with_explicit_dtype(self) -> None: ...
    def test_spacedelimiter(self) -> None: ...
    def test_integer_delimiter(self) -> None: ...
    def test_missing(self): ...
    def test_missing_with_tabs(self) -> None: ...
    def test_usecols(self) -> None: ...
    def test_usecols_as_css(self) -> None: ...
    def test_usecols_with_structured_dtype(self) -> None: ...
    def test_usecols_with_integer(self) -> None: ...
    def test_usecols_with_named_columns(self) -> None: ...
    def test_empty_file(self) -> None: ...
    def test_fancy_dtype_alt(self) -> None: ...
    def test_shaped_dtype(self) -> None: ...
    def test_withmissing(self) -> None: ...
    def test_user_missing_values(self) -> None: ...
    def test_user_filling_values(self) -> None: ...
    def test_withmissing_float(self) -> None: ...
    def test_with_masked_column_uniform(self) -> None: ...
    def test_with_masked_column_various(self) -> None: ...
    def test_invalid_raise(self): ...
    def test_invalid_raise_with_usecols(self): ...
    def test_inconsistent_dtype(self): ...
    def test_default_field_format(self) -> None: ...
    def test_single_dtype_wo_names(self) -> None: ...
    def test_single_dtype_w_explicit_names(self) -> None: ...
    def test_single_dtype_w_implicit_names(self) -> None: ...
    def test_easy_structured_dtype(self) -> None: ...
    def test_autostrip(self) -> None: ...
    def test_replace_space(self) -> None: ...
    def test_replace_space_known_dtype(self) -> None: ...
    def test_incomplete_names(self) -> None: ...
    def test_names_auto_completion(self) -> None: ...
    def test_names_with_usecols_bug1636(self) -> None: ...
    def test_fixed_width_names(self) -> None: ...
    def test_filling_values(self) -> None: ...
    def test_comments_is_none(self) -> None: ...
    def test_latin1(self) -> None: ...
    def test_binary_decode_autodtype(self) -> None: ...
    def test_utf8_byte_encoding(self) -> None: ...
    def test_utf8_file(self) -> None: ...
    def test_utf8_file_nodtype_unicode(self) -> None: ...
    def test_recfromtxt(self) -> None: ...
    def test_recfromcsv(self): ...
    def test_max_rows(self) -> None: ...
    def test_gft_using_filename(self) -> None: ...
    def test_gft_from_gzip(self) -> None: ...
    def test_gft_using_generator(self) -> None: ...
    def test_auto_dtype_largeint(self) -> None: ...
    def test_unpack_float_data(self) -> None: ...
    def test_unpack_structured(self) -> None: ...
    def test_unpack_auto_dtype(self) -> None: ...
    def test_unpack_single_name(self) -> None: ...
    def test_squeeze_scalar(self) -> None: ...
    def test_ndmin_keyword(self, ndim: int): ...

class TestPathUsage:
    def test_loadtxt(self) -> None: ...
    def test_save_load(self) -> None: ...
    def test_save_load_memmap(self) -> None: ...
    def test_save_load_memmap_readwrite(self) -> None: ...
    def test_savez_load(self) -> None: ...
    def test_savez_compressed_load(self) -> None: ...
    def test_genfromtxt(self) -> None: ...
    def test_recfromtxt(self) -> None: ...
    def test_recfromcsv(self) -> None: ...

def test_gzip_load() -> None: ...

class JustWriter:
    base: Incomplete
    def __init__(self, base) -> None: ...
    def write(self, s): ...
    def flush(self): ...

class JustReader:
    base: Incomplete
    def __init__(self, base) -> None: ...
    def read(self, n): ...
    def seek(self, off, whence: int = 0): ...

def test_ducktyping() -> None: ...
def test_gzip_loadtxt() -> None: ...
def test_gzip_loadtxt_from_string() -> None: ...
def test_npzfile_dict() -> None: ...
def test_load_refcount() -> None: ...
