from _typeshed import Incomplete
from numpy.testing import assert_ as assert_, assert_almost_equal as assert_almost_equal, assert_array_equal as assert_array_equal, assert_equal as assert_equal, assert_raises as assert_raises, suppress_warnings as suppress_warnings

class TestSignatureMatch:
    NANFUNCS: Incomplete
    IDS: Incomplete
    @staticmethod
    def get_signature(func, default: str = '...'): ...
    def test_signature_match(self, nan_func, func) -> None: ...
    def test_exhaustiveness(self) -> None: ...

class TestNanFunctions_MinMax:
    nanfuncs: Incomplete
    stdfuncs: Incomplete
    def test_mutation(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_out(self) -> None: ...
    def test_dtype_from_input(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_masked(self) -> None: ...
    def test_scalar(self) -> None: ...
    def test_subclass(self) -> None: ...
    def test_object_array(self) -> None: ...
    def test_initial(self, dtype) -> None: ...
    def test_where(self, dtype) -> None: ...

class TestNanFunctions_ArgminArgmax:
    nanfuncs: Incomplete
    def test_mutation(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_empty(self) -> None: ...
    def test_scalar(self) -> None: ...
    def test_subclass(self) -> None: ...
    def test_keepdims(self, dtype) -> None: ...
    def test_out(self, dtype) -> None: ...

class TestNanFunctions_NumberTypes:
    nanfuncs: Incomplete
    nanfunc_ids: Incomplete
    def test_nanfunc(self, mat, dtype, nanfunc, func) -> None: ...
    def test_nanfunc_q(self, mat, dtype, nanfunc, func) -> None: ...
    def test_nanfunc_ddof(self, mat, dtype, nanfunc, func) -> None: ...

class SharedNanFunctionsTestsMixin:
    def test_mutation(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_out(self) -> None: ...
    def test_dtype_from_dtype(self) -> None: ...
    def test_dtype_from_char(self) -> None: ...
    def test_dtype_from_input(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_scalar(self) -> None: ...
    def test_subclass(self) -> None: ...

class TestNanFunctions_SumProd(SharedNanFunctionsTestsMixin):
    nanfuncs: Incomplete
    stdfuncs: Incomplete
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_empty(self) -> None: ...
    def test_initial(self, dtype) -> None: ...
    def test_where(self, dtype) -> None: ...

class TestNanFunctions_CumSumProd(SharedNanFunctionsTestsMixin):
    nanfuncs: Incomplete
    stdfuncs: Incomplete
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_empty(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_out(self) -> None: ...

class TestNanFunctions_MeanVarStd(SharedNanFunctionsTestsMixin):
    nanfuncs: Incomplete
    stdfuncs: Incomplete
    def test_dtype_error(self) -> None: ...
    def test_out_dtype_error(self) -> None: ...
    def test_ddof(self) -> None: ...
    def test_ddof_too_big(self) -> None: ...
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_empty(self) -> None: ...
    def test_where(self, dtype) -> None: ...

class TestNanFunctions_Median:
    def test_mutation(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_out(self) -> None: ...
    def test_small_large(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_allnans(self, dtype, axis) -> None: ...
    def test_empty(self) -> None: ...
    def test_scalar(self) -> None: ...
    def test_extended_axis_invalid(self) -> None: ...
    def test_float_special(self) -> None: ...

class TestNanFunctions_Percentile:
    def test_mutation(self) -> None: ...
    def test_keepdims(self) -> None: ...
    def test_out(self) -> None: ...
    def test_result_values(self) -> None: ...
    def test_allnans(self, axis, dtype, array) -> None: ...
    def test_empty(self) -> None: ...
    def test_scalar(self) -> None: ...
    def test_extended_axis_invalid(self) -> None: ...
    def test_multiple_percentiles(self) -> None: ...

class TestNanFunctions_Quantile:
    def test_regression(self) -> None: ...
    def test_basic(self) -> None: ...
    def test_no_p_overwrite(self) -> None: ...
    def test_allnans(self, axis, dtype, array) -> None: ...

def test__nan_mask(arr, expected) -> None: ...
def test__replace_nan() -> None: ...
