import numpy as np
from _typeshed import Incomplete
from numpy.lib.recfunctions import append_fields as append_fields, apply_along_fields as apply_along_fields, assign_fields_by_name as assign_fields_by_name, drop_fields as drop_fields, find_duplicates as find_duplicates, get_fieldstructure as get_fieldstructure, join_by as join_by, merge_arrays as merge_arrays, recursive_fill_fields as recursive_fill_fields, rename_fields as rename_fields, repack_fields as repack_fields, require_fields as require_fields, stack_arrays as stack_arrays, structured_to_unstructured as structured_to_unstructured, unstructured_to_structured as unstructured_to_structured
from numpy.ma.mrecords import MaskedRecords as MaskedRecords
from numpy.ma.testutils import assert_equal as assert_equal
from numpy.testing import assert_ as assert_, assert_raises as assert_raises

get_fieldspec: Incomplete
get_names = np.lib.recfunctions.get_names
get_names_flat = np.lib.recfunctions.get_names_flat
zip_descr: Incomplete
zip_dtype: Incomplete

class TestRecFunctions:
    data: Incomplete
    def setup_method(self) -> None: ...
    def test_zip_descr(self) -> None: ...
    def test_drop_fields(self) -> None: ...
    def test_rename_fields(self) -> None: ...
    def test_get_names(self) -> None: ...
    def test_get_names_flat(self) -> None: ...
    def test_get_fieldstructure(self) -> None: ...
    def test_find_duplicates(self) -> None: ...
    def test_find_duplicates_ignoremask(self) -> None: ...
    def test_repack_fields(self) -> None: ...
    def test_structured_to_unstructured(self): ...
    def test_field_assignment_by_name(self) -> None: ...

class TestRecursiveFillFields:
    def test_simple_flexible(self) -> None: ...
    def test_masked_flexible(self) -> None: ...

class TestMergeArrays:
    data: Incomplete
    def setup_method(self) -> None: ...
    def test_solo(self) -> None: ...
    def test_solo_w_flatten(self) -> None: ...
    def test_standard(self) -> None: ...
    def test_flatten(self) -> None: ...
    def test_flatten_wflexible(self) -> None: ...
    def test_wmasked_arrays(self) -> None: ...
    def test_w_singlefield(self) -> None: ...
    def test_w_shorter_flex(self) -> None: ...
    def test_singlerecord(self) -> None: ...

class TestAppendFields:
    data: Incomplete
    def setup_method(self) -> None: ...
    def test_append_single(self) -> None: ...
    def test_append_double(self) -> None: ...
    def test_append_on_flex(self) -> None: ...
    def test_append_on_nested(self) -> None: ...

class TestStackArrays:
    data: Incomplete
    def setup_method(self) -> None: ...
    def test_solo(self) -> None: ...
    def test_unnamed_fields(self) -> None: ...
    def test_unnamed_and_named_fields(self) -> None: ...
    def test_matching_named_fields(self) -> None: ...
    def test_defaults(self) -> None: ...
    def test_autoconversion(self) -> None: ...
    def test_checktitles(self) -> None: ...
    def test_subdtype(self) -> None: ...

class TestJoinBy:
    a: Incomplete
    b: Incomplete
    def setup_method(self) -> None: ...
    def test_inner_join(self) -> None: ...
    def test_join(self) -> None: ...
    def test_join_subdtype(self) -> None: ...
    def test_outer_join(self) -> None: ...
    def test_leftouter_join(self) -> None: ...
    def test_different_field_order(self) -> None: ...
    def test_duplicate_keys(self) -> None: ...
    def test_same_name_different_dtypes_key(self) -> None: ...
    def test_same_name_different_dtypes(self) -> None: ...
    def test_subarray_key(self) -> None: ...
    def test_padded_dtype(self) -> None: ...

class TestJoinBy2:
    @classmethod
    def setup_method(cls) -> None: ...
    def test_no_r1postfix(self) -> None: ...
    def test_no_postfix(self) -> None: ...
    def test_no_r2postfix(self) -> None: ...
    def test_two_keys_two_vars(self) -> None: ...

class TestAppendFieldsObj:
    data: Incomplete
    def setup_method(self) -> None: ...
    def test_append_to_objects(self) -> None: ...
